#! /usr/bin/python

import os
from petmail import util

class LogBundle(object):

    def __init__(self):
        self.logs = {}
    def addLog(self, log):
        self.logs[log.name] = log

class Log(object):
    """A size-limited record of events.

    
    """
    maxItems = 100

    def __init__(self, name):
        self.name = name
        self.items = []
        self.observers = []
        if os.environ.get("LOGMEBABY"):
            self.observers.append(self.printEvent)

    def __getstate__(self):
        d = self.__dict__.copy()
        d['observers'] = []
        return d

    def addObserver(self, observer):
        self.observers.append(observer)
    def removeObserver(self, observer):
        self.observers.remove(observer)

    def printEvent(self, eventDict):
        print ' '.join(map(str, eventDict['message']))

    def addEvent(self, eventDict):
        self.items.append(eventDict)
        for o in self.observers:
            o(eventDict)
        if len(self.items) > self.maxItems:
            self.items.pop(0)
        
    def add(self, *args):
        now = util.now()
        self.addEvent({'time': util.now(),
                       'message': args,
                       })

